/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 13.05.2010
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

#include <delay.h>

#define dig2 PORTD.5//PORTD.5        dig1
#define dig1 PORTD.6//PORTD.6        dig2
#define dig0 PORTD.7//PORTD.7       dig3
#define seg_mask (0b00000001) //  B
volatile unsigned char adc_data;//    
/*******************************************************************************************************************************/
/*********************   *****************************
              a
            -----
          f|     |b
           |  g  |
            -----
          e|     |c
           |  d  |
            ----- *h
PINB0        ,     
g      f      e      d      c      b      a      in
pb7    pb6    pb5    pb4    pb3    pb2    pb1    pb0
**********************/
unsigned char sym[]={
0b10000000, //(0)0
0b11110010, //(1)1
0b01001000, //(2)2
0b01100000, //(3)3
0b00110010, //(4)4
0b00100100, //(5)5
0b00000100, //(6)6
0b11110000, //(7)7
0b10000000, //(8)8
0b00100000, //(9)9
0b00001100, //(10)E
0b01011110, //(11)r
0b11111110  //(12)  
};
volatile unsigned char cur_dig;   //  
volatile unsigned char sym_out[3];// sym_out   ( 3)        
void recoding (void){    //     
//if (adc_data<255)       //  indication  255 
sym_out[0]=adc_data%10;  //  digit_out 0        
adc_data=adc_data/10;    //  indication      380  38
sym_out[1]=adc_data%10;  //  8   
adc_data=adc_data/10;    // 38  3
sym_out[2]=adc_data;     //    3
//else                     // 
//sym_out[0]=sym[11];      //
//sym_out[1]=sym[10];      //Er
}

interrupt [TIM0_OVF] void timer0_ovf_isr(void)//        timer0
{
PORTB=sym[12];                           //  B
switch (cur_dig){                        //   
case 0:{dig0=1; dig1=0; dig2=0; break;}; //    3
case 1:{dig1=1; dig2=0; dig0=0; break;}; //    2
case 2:{dig2=1; dig0=0; dig1=0; break;}; //    1
}

if (adc_data<10)                        //  adc_data<10
sym_out[2]=sym[12]; sym_out[1]=sym[12]; //    1  2
//if (adc_data<100)                       //  adc_data<100
//sym_out[2]=sym[12];                     //    1
PORTB=sym[sym_out[cur_dig]];
cur_dig=cur_dig+1;               //  cur_dig  1
if (cur_dig==3) cur_dig=0;       //  cur_dig     3
} 
/******************************************************************************************************************************/

// ADC interrupt service routine
void adc_isr(void)
{
adc_data=ADCH;//   adc_data     ADCH
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=In 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=P 
PORTB=0xFF;
DDRB=0xFE;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State6=P State5=P State4=T State3=P State2=1 State1=1 State0=1 
PORTC=0x6F;
DDRC=0x07;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=1 State6=1 State5=1 State4=1 State3=P State2=P State1=P State0=P 
PORTD=0xFF;
DDRD=0xF0;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
TCCR0=0x04;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
GICR|=0x40;
MCUCR=0x02;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

//  ADC
//  ADC 62,500 kHz
//    2,56V
//   8 
//       ADC7
ADMUX=0xE7;
ADCSRA=0x87;

// Global enable interrupts
#asm("sei")

while (1)
      {
      ADCSRA|=0xC7;// 
      adc_isr();   //   
      recoding();  //  
      };
}
